/*
 * Copyright (c)  2018 Wise Wild Web .
 *
 *  MIT License
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 * @author : Nathanael Braun
 * @contact : caipilabs@gmail.com
 */

'use strict';

import React from "react";
import {Scope} from "../../Rescope";
import {rescopeProps} from "../../ReactTools";

class NewsListComp extends React.Component {
    static use = ["userEvents"];
    render() {
        return (
            <div className="NewsListComp container" style={{minHeight : "100%"}}>
                <h1>Mes events</h1>
                {
                    this.props.userEvents &&
                    this.props.userEvents.events.map(
                        ( evt, i ) =>
                            <div style={{border : "solid 1px lightgrey", borderRadius : "3px"}} key={i}>
                                <b><u>
                                    <center>Event type : {evt.type}</center>
                                </u></b>
                                <p>{evt.text}</p>
                            </div>
                    )
                }

            </div>
        );
    }
};

export default rescopeProps(NewsListComp);